/*
 * Vector.java
 *
 * Created on July 24, 2008, 3:28 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @author dsmith
 */
public class Vector { 
    private int dimension;
    public double x;
    public double y;
    public double z;
    public double p; // 
    public double q; // 

    /** Creates a new instance of Vector */
    public Vector(int d) {
        dimension = d;
    }
    
    public Vector(double x, double y) {
        this.x = x;
        this.y = y;
        dimension = 2;
    }
    
    public Vector(double x, double y, double z) {
        this.x = x;
        this.y = y;
        this.z = z;
        dimension = 3;
    }
    
    public Vector(double x, double y, double z, double p, double q) {
        this.x = x;
        this.y = y;
        this.z = z;
        this.p = p;
        this.q = q;
        dimension = 5;
    }
    
    public Vector(Vector v) {
        dimension = v.dimension;
        x = v.x;
        y = v.y;
        z = v.z;
        p = v.p;
        q = v.q;
    }
    
    /*
     * a deep copy add
     */
    public Vector add(Vector v) {
        Vector res = new Vector(x + v.x, y + v.y, z + v.z, p + v.p, q + v.q);
        res.dimension = dimension;
        return res;
    }
    
    public void incr(Vector v) {
        x += v.x;
        y += v.y;
        if(v.dimension > 2) {
            z += v.z;
            p += v.p;
            q += v.q;
        }
    }
    
    public void decr(Vector v) {
        x -= v.x;
        y -= v.y;
        if(v.dimension > 2) {
            z -= v.z;
            p -= v.p;
            q -= v.q;
        }
    }
    
    public void copyValues(Vector v) {
        x = v.x;
        y = v.y;
        if(v.dimension > 2) {
            z = v.z;
            if(v.dimension > 3) {
                p = v.p;
                q = v.q;
            }
        }
    }
    
    public void scale(double f) {
        x *= f;
        y *= f;
        z *= f;
    }
    
    public double size() {
        return Math.sqrt(x*x * y*y + z*z);
    }
    
    public void setDimension(int it) {
        dimension = it;
    }
    
    public String toString() {
        String res = "{ ";
        res += x + " ";
        res += y + " ";
        if(dimension > 2) {
            res += y + " ";
        }
        if(dimension > 3) {
            res += p + " ";
            res += q + " ";
        }
        res += "}";
        return res;
    }
}
